<template>
    <div class="notification">
        <transition-group
            name="transition-animate"
            class="messages-list"
        >
            <div
                class="notification_content"
                v-for="message in messages"
                :key="message.id"
            >
                <div class="content_text">
                    <span>{{ message.name }}</span>
                    <i class="material-icons">check</i>
                </div>
            </div>
        </transition-group>
    </div>
</template>

<script>
export default {
    name: "Notification",
    props: {
        messages: {
            type: Array,
            default: () => {
                return []
            }
        }
    },
    methods: {
        hideNotification() {
            let vm = this;
            if(this.messages.length) {
                setTimeout(function (){
                    vm.messages.splice(vm.messages.length - 1, 1)
                }, 3000)
            }
        }
    },
    watch: {
        messages() {
            this.hideNotification();
        }
    },
    mounted() {
        this.hideNotification();
    }
}
</script>

<style lang="scss">
    .notification {
        position: fixed;
        top: 150px;
        right: 20px;
        z-index: 20;

        &_messages_list {
            display: flex;
            flex-direction: column-reverse;
        }

        &_content {
            padding: 16px;
            border-radius: 4px;
            color: #FFFFFF;
            display: flex;
            justify-content: space-between;
            align-items: center;
            height: 50px;
            margin-bottom: 16px;
            background: rgb(32, 128, 55);
        }

        .content {
            &_text {
                display: flex;
                align-items: center;
                justify-content: space-between;
            }
        }

        .material-icons {
            margin-left: 16px;
        }
    }
    .transition-animate {
        &-enter {
            transform: translateX(220px);
            opacity: 0;
        }
        &-enter-active {
            transition: all .6s ease;
        }
        &-enter-to {
            opacity: 1;
        }

        &-leave {
            height: 50px;
            opacity: 1;
        }
        &-leave-active {
            transition: transform .6s ease, opacity .6s, height .6s .2s;
        }
        &-leave-to {
            height: 0;
            transform: translateX(220px);
            opacity: 0;
        }

        &-move {
            transition: transform .6s ease;
        }
    }
</style>
